<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE mapper PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN"
"mybatis-3-mapper.dtd">
<mapper namespace="com.mortals.xhx.module.matter.dao.ibatis.MatterDaoImpl">

    <!-- 字段和属性映射 -->
    <resultMap type="MatterEntity" id="MatterEntity-Map">
            <id  property="id" column="id" />
            <result property="siteId" column="siteId" />
            <result property="tid" column="tid" />
            <result property="tcode" column="tcode" />
            <result property="tname" column="tname" />
            <result property="matterName" column="matterName" />
            <result property="englishName" column="englishName" />
            <result property="matterNo" column="matterNo" />
            <result property="matterFullName" column="matterFullName" />
            <result property="deptId" column="deptId" />
            <result property="deptName" column="deptName" />
            <result property="total" column="total" />
            <result property="sort" column="sort" />
            <result property="isRecommend" column="isRecommend" />
            <result property="source" column="source" />
            <result property="createTime" column="createTime" />
            <result property="createUserId" column="createUserId" />
            <result property="updateTime" column="updateTime" />
            
    </resultMap>


    <!-- 表所有列 -->
    <sql id="_columns">
        <trim suffixOverrides="," suffix="">
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('id') or colPickMode == 1 and data.containsKey('id')))">
                    a.id,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('siteId') or colPickMode == 1 and data.containsKey('siteId')))">
                    a.siteId,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('tid') or colPickMode == 1 and data.containsKey('tid')))">
                    a.tid,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('tcode') or colPickMode == 1 and data.containsKey('tcode')))">
                    a.tcode,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('tname') or colPickMode == 1 and data.containsKey('tname')))">
                    a.tname,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('matterName') or colPickMode == 1 and data.containsKey('matterName')))">
                    a.matterName,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('englishName') or colPickMode == 1 and data.containsKey('englishName')))">
                    a.englishName,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('matterNo') or colPickMode == 1 and data.containsKey('matterNo')))">
                    a.matterNo,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('matterFullName') or colPickMode == 1 and data.containsKey('matterFullName')))">
                    a.matterFullName,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('deptId') or colPickMode == 1 and data.containsKey('deptId')))">
                    a.deptId,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('deptName') or colPickMode == 1 and data.containsKey('deptName')))">
                    a.deptName,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('total') or colPickMode == 1 and data.containsKey('total')))">
                    a.total,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('sort') or colPickMode == 1 and data.containsKey('sort')))">
                    a.sort,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('isRecommend') or colPickMode == 1 and data.containsKey('isRecommend')))">
                    a.isRecommend,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('source') or colPickMode == 1 and data.containsKey('source')))">
                    a.source,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('createTime') or colPickMode == 1 and data.containsKey('createTime')))">
                    a.createTime,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('createUserId') or colPickMode == 1 and data.containsKey('createUserId')))">
                    a.createUserId,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('updateTime') or colPickMode == 1 and data.containsKey('updateTime')))">
                    a.updateTime,
                </if>
        </trim>
    </sql>
    <!-- 新增 区分主键自增加还是业务插入 -->
    <insert id="insert" parameterType="MatterEntity"  useGeneratedKeys="true" keyProperty="id">
        insert into mortals_xhx_matter
        (siteId,tid,tcode,tname,matterName,englishName,matterNo,matterFullName,deptId,deptName,total,sort,isRecommend,source,createTime,createUserId,updateTime)
        VALUES
        (#{siteId},#{tid},#{tcode},#{tname},#{matterName},#{englishName},#{matterNo},#{matterFullName},#{deptId},#{deptName},#{total},#{sort},#{isRecommend},#{source},#{createTime},#{createUserId},#{updateTime})
    </insert>

    <!-- 批量新增 -->
    <insert id="insertBatch" parameterType="paramDto">
        insert into mortals_xhx_matter
        (siteId,tid,tcode,tname,matterName,englishName,matterNo,matterFullName,deptId,deptName,total,sort,isRecommend,source,createTime,createUserId,updateTime)
        VALUES
        <foreach collection="data.dataList" item="item" index="index" separator="," >
            (#{item.siteId},#{item.tid},#{item.tcode},#{item.tname},#{item.matterName},#{item.englishName},#{item.matterNo},#{item.matterFullName},#{item.deptId},#{item.deptName},#{item.total},#{item.sort},#{item.isRecommend},#{item.source},#{item.createTime},#{item.createUserId},#{item.updateTime})
        </foreach>
    </insert>


    <!-- 根据ParamDto更新 -->
    <update id="update" parameterType="paramDto">
        update mortals_xhx_matter as a
        set
        <trim suffixOverrides="," suffix="">
            <if test="(colPickMode==0 and data.containsKey('siteId')) or (colPickMode==1 and !data.containsKey('siteId'))">
                a.siteId=#{data.siteId},
            </if>
            <if test="(colPickMode==0 and data.containsKey('siteIdIncrement')) or (colPickMode==1 and !data.containsKey('siteIdIncrement'))">
                a.siteId=ifnull(a.siteId,0) + #{data.siteIdIncrement},
            </if>
            <if test="(colPickMode==0 and data.containsKey('tid')) or (colPickMode==1 and !data.containsKey('tid'))">
                a.tid=#{data.tid},
            </if>
            <if test="(colPickMode==0 and data.containsKey('tcode')) or (colPickMode==1 and !data.containsKey('tcode'))">
                a.tcode=#{data.tcode},
            </if>
            <if test="(colPickMode==0 and data.containsKey('tname')) or (colPickMode==1 and !data.containsKey('tname'))">
                a.tname=#{data.tname},
            </if>
            <if test="(colPickMode==0 and data.containsKey('matterName')) or (colPickMode==1 and !data.containsKey('matterName'))">
                a.matterName=#{data.matterName},
            </if>
            <if test="(colPickMode==0 and data.containsKey('englishName')) or (colPickMode==1 and !data.containsKey('englishName'))">
                a.englishName=#{data.englishName},
            </if>
            <if test="(colPickMode==0 and data.containsKey('matterNo')) or (colPickMode==1 and !data.containsKey('matterNo'))">
                a.matterNo=#{data.matterNo},
            </if>
            <if test="(colPickMode==0 and data.containsKey('matterFullName')) or (colPickMode==1 and !data.containsKey('matterFullName'))">
                a.matterFullName=#{data.matterFullName},
            </if>
            <if test="(colPickMode==0 and data.containsKey('deptId')) or (colPickMode==1 and !data.containsKey('deptId'))">
                a.deptId=#{data.deptId},
            </if>
            <if test="(colPickMode==0 and data.containsKey('deptIdIncrement')) or (colPickMode==1 and !data.containsKey('deptIdIncrement'))">
                a.deptId=ifnull(a.deptId,0) + #{data.deptIdIncrement},
            </if>
            <if test="(colPickMode==0 and data.containsKey('deptName')) or (colPickMode==1 and !data.containsKey('deptName'))">
                a.deptName=#{data.deptName},
            </if>
            <if test="(colPickMode==0 and data.containsKey('total')) or (colPickMode==1 and !data.containsKey('total'))">
                a.total=#{data.total},
            </if>
            <if test="(colPickMode==0 and data.containsKey('totalIncrement')) or (colPickMode==1 and !data.containsKey('totalIncrement'))">
                a.total=ifnull(a.total,0) + #{data.totalIncrement},
            </if>
            <if test="(colPickMode==0 and data.containsKey('sort')) or (colPickMode==1 and !data.containsKey('sort'))">
                a.sort=#{data.sort},
            </if>
            <if test="(colPickMode==0 and data.containsKey('sortIncrement')) or (colPickMode==1 and !data.containsKey('sortIncrement'))">
                a.sort=ifnull(a.sort,0) + #{data.sortIncrement},
            </if>
            <if test="(colPickMode==0 and data.containsKey('isRecommend')) or (colPickMode==1 and !data.containsKey('isRecommend'))">
                a.isRecommend=#{data.isRecommend},
            </if>
            <if test="(colPickMode==0 and data.containsKey('isRecommendIncrement')) or (colPickMode==1 and !data.containsKey('isRecommendIncrement'))">
                a.isRecommend=ifnull(a.isRecommend,0) + #{data.isRecommendIncrement},
            </if>
            <if test="(colPickMode==0 and data.containsKey('source')) or (colPickMode==1 and !data.containsKey('source'))">
                a.source=#{data.source},
            </if>
            <if test="(colPickMode==0 and data.containsKey('sourceIncrement')) or (colPickMode==1 and !data.containsKey('sourceIncrement'))">
                a.source=ifnull(a.source,0) + #{data.sourceIncrement},
            </if>
            <if test="(colPickMode==0 and data.containsKey('createTime')) or (colPickMode==1 and !data.containsKey('createTime'))">
                a.createTime=#{data.createTime},
            </if>
            <if test="(colPickMode==0 and data.containsKey('createUserId')) or (colPickMode==1 and !data.containsKey('createUserId'))">
                a.createUserId=#{data.createUserId},
            </if>
            <if test="(colPickMode==0 and data.containsKey('createUserIdIncrement')) or (colPickMode==1 and !data.containsKey('createUserIdIncrement'))">
                a.createUserId=ifnull(a.createUserId,0) + #{data.createUserIdIncrement},
            </if>
            <if test="(colPickMode==0 and data.containsKey('updateTime')) or (colPickMode==1 and !data.containsKey('updateTime'))">
                a.updateTime=#{data.updateTime},
            </if>
        </trim>
        <trim suffixOverrides="where" suffix="">
            where
            <trim prefixOverrides="and" prefix="">
                <include refid="_condition_"/>
            </trim>
        </trim>
    </update>
    <!-- 批量更新 -->
    <update id="updateBatch" parameterType="paramDto">
        update mortals_xhx_matter as a
        <trim prefix="set" suffixOverrides=",">
                        <trim prefix="siteId=(case" suffix="ELSE siteId end),">
                            <foreach collection="data.dataList" item="item" index="index" separator="" >
                                <choose>
                                    <when test="(colPickMode==0 and item.containsKey('siteId')) or (colPickMode==1 and !item.containsKey('siteId'))">
                                        when a.id=#{item.id} then #{item.siteId}
                                    </when>
                                    <when test="(colPickMode==0 and item.containsKey('siteIdIncrement')) or (colPickMode==1 and !item.containsKey('siteIdIncrement'))">
                                        when a.id=#{item.id} then ifnull(a.siteId,0) + #{item.siteIdIncrement}
                                    </when>
                                </choose>
                            </foreach>
                        </trim>
                <trim prefix="tid=(case" suffix="ELSE tid end),">
                    <foreach collection="data.dataList" item="item" index="index" separator="" >
                        <if test="(colPickMode==0 and item.containsKey('tid')) or (colPickMode==1 and !item.containsKey('tid'))">
                            when a.id=#{item.id} then #{item.tid}
                        </if>
                    </foreach>
                </trim>
                <trim prefix="tcode=(case" suffix="ELSE tcode end),">
                    <foreach collection="data.dataList" item="item" index="index" separator="" >
                        <if test="(colPickMode==0 and item.containsKey('tcode')) or (colPickMode==1 and !item.containsKey('tcode'))">
                            when a.id=#{item.id} then #{item.tcode}
                        </if>
                    </foreach>
                </trim>
                <trim prefix="tname=(case" suffix="ELSE tname end),">
                    <foreach collection="data.dataList" item="item" index="index" separator="" >
                        <if test="(colPickMode==0 and item.containsKey('tname')) or (colPickMode==1 and !item.containsKey('tname'))">
                            when a.id=#{item.id} then #{item.tname}
                        </if>
                    </foreach>
                </trim>
                <trim prefix="matterName=(case" suffix="ELSE matterName end),">
                    <foreach collection="data.dataList" item="item" index="index" separator="" >
                        <if test="(colPickMode==0 and item.containsKey('matterName')) or (colPickMode==1 and !item.containsKey('matterName'))">
                            when a.id=#{item.id} then #{item.matterName}
                        </if>
                    </foreach>
                </trim>
                <trim prefix="englishName=(case" suffix="ELSE englishName end),">
                    <foreach collection="data.dataList" item="item" index="index" separator="" >
                        <if test="(colPickMode==0 and item.containsKey('englishName')) or (colPickMode==1 and !item.containsKey('englishName'))">
                            when a.id=#{item.id} then #{item.englishName}
                        </if>
                    </foreach>
                </trim>
                <trim prefix="matterNo=(case" suffix="ELSE matterNo end),">
                    <foreach collection="data.dataList" item="item" index="index" separator="" >
                        <if test="(colPickMode==0 and item.containsKey('matterNo')) or (colPickMode==1 and !item.containsKey('matterNo'))">
                            when a.id=#{item.id} then #{item.matterNo}
                        </if>
                    </foreach>
                </trim>
                <trim prefix="matterFullName=(case" suffix="ELSE matterFullName end),">
                    <foreach collection="data.dataList" item="item" index="index" separator="" >
                        <if test="(colPickMode==0 and item.containsKey('matterFullName')) or (colPickMode==1 and !item.containsKey('matterFullName'))">
                            when a.id=#{item.id} then #{item.matterFullName}
                        </if>
                    </foreach>
                </trim>
                        <trim prefix="deptId=(case" suffix="ELSE deptId end),">
                            <foreach collection="data.dataList" item="item" index="index" separator="" >
                                <choose>
                                    <when test="(colPickMode==0 and item.containsKey('deptId')) or (colPickMode==1 and !item.containsKey('deptId'))">
                                        when a.id=#{item.id} then #{item.deptId}
                                    </when>
                                    <when test="(colPickMode==0 and item.containsKey('deptIdIncrement')) or (colPickMode==1 and !item.containsKey('deptIdIncrement'))">
                                        when a.id=#{item.id} then ifnull(a.deptId,0) + #{item.deptIdIncrement}
                                    </when>
                                </choose>
                            </foreach>
                        </trim>
                <trim prefix="deptName=(case" suffix="ELSE deptName end),">
                    <foreach collection="data.dataList" item="item" index="index" separator="" >
                        <if test="(colPickMode==0 and item.containsKey('deptName')) or (colPickMode==1 and !item.containsKey('deptName'))">
                            when a.id=#{item.id} then #{item.deptName}
                        </if>
                    </foreach>
                </trim>
                        <trim prefix="total=(case" suffix="ELSE total end),">
                            <foreach collection="data.dataList" item="item" index="index" separator="" >
                                <choose>
                                    <when test="(colPickMode==0 and item.containsKey('total')) or (colPickMode==1 and !item.containsKey('total'))">
                                        when a.id=#{item.id} then #{item.total}
                                    </when>
                                    <when test="(colPickMode==0 and item.containsKey('totalIncrement')) or (colPickMode==1 and !item.containsKey('totalIncrement'))">
                                        when a.id=#{item.id} then ifnull(a.total,0) + #{item.totalIncrement}
                                    </when>
                                </choose>
                            </foreach>
                        </trim>
                        <trim prefix="sort=(case" suffix="ELSE sort end),">
                            <foreach collection="data.dataList" item="item" index="index" separator="" >
                                <choose>
                                    <when test="(colPickMode==0 and item.containsKey('sort')) or (colPickMode==1 and !item.containsKey('sort'))">
                                        when a.id=#{item.id} then #{item.sort}
                                    </when>
                                    <when test="(colPickMode==0 and item.containsKey('sortIncrement')) or (colPickMode==1 and !item.containsKey('sortIncrement'))">
                                        when a.id=#{item.id} then ifnull(a.sort,0) + #{item.sortIncrement}
                                    </when>
                                </choose>
                            </foreach>
                        </trim>
                        <trim prefix="isRecommend=(case" suffix="ELSE isRecommend end),">
                            <foreach collection="data.dataList" item="item" index="index" separator="" >
                                <choose>
                                    <when test="(colPickMode==0 and item.containsKey('isRecommend')) or (colPickMode==1 and !item.containsKey('isRecommend'))">
                                        when a.id=#{item.id} then #{item.isRecommend}
                                    </when>
                                    <when test="(colPickMode==0 and item.containsKey('isRecommendIncrement')) or (colPickMode==1 and !item.containsKey('isRecommendIncrement'))">
                                        when a.id=#{item.id} then ifnull(a.isRecommend,0) + #{item.isRecommendIncrement}
                                    </when>
                                </choose>
                            </foreach>
                        </trim>
                        <trim prefix="source=(case" suffix="ELSE source end),">
                            <foreach collection="data.dataList" item="item" index="index" separator="" >
                                <choose>
                                    <when test="(colPickMode==0 and item.containsKey('source')) or (colPickMode==1 and !item.containsKey('source'))">
                                        when a.id=#{item.id} then #{item.source}
                                    </when>
                                    <when test="(colPickMode==0 and item.containsKey('sourceIncrement')) or (colPickMode==1 and !item.containsKey('sourceIncrement'))">
                                        when a.id=#{item.id} then ifnull(a.source,0) + #{item.sourceIncrement}
                                    </when>
                                </choose>
                            </foreach>
                        </trim>
                <trim prefix="createTime=(case" suffix="ELSE createTime end),">
                    <foreach collection="data.dataList" item="item" index="index" separator="" >
                        <if test="(colPickMode==0 and item.containsKey('createTime')) or (colPickMode==1 and !item.containsKey('createTime'))">
                            when a.id=#{item.id} then #{item.createTime}
                        </if>
                    </foreach>
                </trim>
                        <trim prefix="createUserId=(case" suffix="ELSE createUserId end),">
                            <foreach collection="data.dataList" item="item" index="index" separator="" >
                                <choose>
                                    <when test="(colPickMode==0 and item.containsKey('createUserId')) or (colPickMode==1 and !item.containsKey('createUserId'))">
                                        when a.id=#{item.id} then #{item.createUserId}
                                    </when>
                                    <when test="(colPickMode==0 and item.containsKey('createUserIdIncrement')) or (colPickMode==1 and !item.containsKey('createUserIdIncrement'))">
                                        when a.id=#{item.id} then ifnull(a.createUserId,0) + #{item.createUserIdIncrement}
                                    </when>
                                </choose>
                            </foreach>
                        </trim>
                <trim prefix="updateTime=(case" suffix="ELSE updateTime end),">
                    <foreach collection="data.dataList" item="item" index="index" separator="" >
                        <if test="(colPickMode==0 and item.containsKey('updateTime')) or (colPickMode==1 and !item.containsKey('updateTime'))">
                            when a.id=#{item.id} then #{item.updateTime}
                        </if>
                    </foreach>
                </trim>
        </trim>
        where id in
        <foreach collection="data.dataList" item="item" index="index" open="(" separator="," close=")">
            #{item.id}
        </foreach>
    </update>
    <!-- 根据主健查询 -->
    <select id="getByKey" parameterType="paramDto" resultMap="MatterEntity-Map">
        select <include refid="_columns"/>
        from mortals_xhx_matter as a
        where a.id=#{condition.id}
    </select>
    <!-- 根据主健删除 -->
    <delete id="deleteByKey" parameterType="paramDto">
        delete a.* from mortals_xhx_matter as a where a.id=#{condition.id}
    </delete>
    <!-- 根据主健删除一批，针对单一主健有效 -->
    <delete id="deleteByKeys">
        delete from mortals_xhx_matter where id in
        <foreach collection="array" item="item" index="index" open="(" separator="," close=")">
            #{item}
        </foreach>
    </delete>
    <!-- 根据paramDto删除一批 -->
    <delete id="deleteByMap" parameterType="paramDto">
        delete a.* from mortals_xhx_matter as a
        <trim suffixOverrides="where" suffix="">
            where
            <trim prefixOverrides="and" prefix="">
                <include refid="_condition_"/>
            </trim>
        </trim>
    </delete>
    <!-- 获取列表 -->
    <select id="getList" parameterType="paramDto" resultMap="MatterEntity-Map">
        select <include refid="_columns"/>
        from mortals_xhx_matter as a
        <trim suffixOverrides="where" suffix="">
            where
            <trim prefixOverrides="and" prefix="">
                <include refid="_condition_"/>
            </trim>
        </trim>
        <include refid="_orderCols_"/>
    </select>



    <!-- 获取 -->
    <select id="getListCount" parameterType="paramDto" resultType="int">
        select count(1)
        from mortals_xhx_matter as a
        <trim suffixOverrides="where" suffix="">
            where
            <trim prefixOverrides="and" prefix="">
                <include refid="_condition_"/>
            </trim>
        </trim>
    </select>
    <!-- 条件映射 -->
    <sql id="_condition_">
        <if test="condition != null and !condition.isEmpty()">
            <!-- 条件映射-普通条件 -->
            <include refid="_condition_param_">
                <property name="_conditionParam_" value="condition"/>
                <property name="_conditionType_" value="and"/>
            </include>
            <!-- 条件映射-集合之间使用AND，集合中元素使用OR-(list[0].1 or list[0].2) and (list[1].3 or list[1].4) -->
            <if test="condition.containsKey('andConditionList') and !condition.andConditionList.isEmpty()">
                and
                <foreach collection="condition.andConditionList" open="(" close=")" index="index" item="andCondition" separator=" and ">
                    <trim prefixOverrides="or" prefix="(" suffix=")">
                        <include refid="_condition_param_">
                            <property name="_conditionParam_" value="andCondition"/>
                            <property name="_conditionType_" value="or"/>
                        </include>
                    </trim>
                </foreach>
            </if>
            <!-- 条件映射-集合之间使用OR，集合中元素使用AND-(list[0].1 and list[0].2) or (list[1].3 and list[1].4) -->
            <if test="condition.containsKey('orConditionList') and !condition.orConditionList.isEmpty()">
                and
                <foreach collection="condition.orConditionList" open="(" close=")" index="index" item="orCondition" separator=" or ">
                    <trim prefixOverrides="and" prefix="(" suffix=")">
                        <include refid="_condition_param_">
                            <property name="_conditionParam_" value="orCondition"/>
                            <property name="_conditionType_" value="and"/>
                        </include>
                    </trim>
                </foreach>
            </if>
        </if>
    </sql>
    <!-- 条件映射-代参数 -->
    <sql id="_condition_param_">
        <bind name="conditionParamRef" value="${_conditionParam_}"/>
        <if test="conditionParamRef.containsKey('id')">
            <if test="conditionParamRef.id != null">
                ${_conditionType_} a.id=#{${_conditionParam_}.id}
            </if>
        </if>
            <if test="conditionParamRef.containsKey('id')">
                <if test="conditionParamRef.id != null ">
                    ${_conditionType_} a.id = #{${_conditionParam_}.id}
                </if>
                <if test="conditionParamRef.id == null">
                    ${_conditionType_} a.id is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('idList')">
                ${_conditionType_} a.id in
                <foreach collection="conditionParamRef.idList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('idStart') and conditionParamRef.idStart != null">
                ${_conditionType_} a.id <![CDATA[ >= ]]> #{${_conditionParam_}.idStart}
            </if>
            <if test="conditionParamRef.containsKey('idEnd') and conditionParamRef.idEnd != null">
                ${_conditionType_} a.id <![CDATA[ <= ]]> #{${_conditionParam_}.idEnd}
            </if>

            <if test="conditionParamRef.containsKey('siteId')">
                <if test="conditionParamRef.siteId != null ">
                    ${_conditionType_} a.siteId = #{${_conditionParam_}.siteId}
                </if>
                <if test="conditionParamRef.siteId == null">
                    ${_conditionType_} a.siteId is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('siteIdList')">
                ${_conditionType_} a.siteId in
                <foreach collection="conditionParamRef.siteIdList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('siteIdStart') and conditionParamRef.siteIdStart != null">
                ${_conditionType_} a.siteId <![CDATA[ >= ]]> #{${_conditionParam_}.siteIdStart}
            </if>
            <if test="conditionParamRef.containsKey('siteIdEnd') and conditionParamRef.siteIdEnd != null">
                ${_conditionType_} a.siteId <![CDATA[ <= ]]> #{${_conditionParam_}.siteIdEnd}
            </if>


            <if test="conditionParamRef.containsKey('tid')">
                <if test="conditionParamRef.tid != null and conditionParamRef.tid != ''">
                    ${_conditionType_} a.tid like #{${_conditionParam_}.tid}
                </if>
                <if test="conditionParamRef.tid == null">
                    ${_conditionType_} a.tid is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('tidList')">
                ${_conditionType_} a.tid in
                <foreach collection="conditionParamRef.tidList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>

            <if test="conditionParamRef.containsKey('tcode')">
                <if test="conditionParamRef.tcode != null and conditionParamRef.tcode != ''">
                    ${_conditionType_} a.tcode like #{${_conditionParam_}.tcode}
                </if>
                <if test="conditionParamRef.tcode == null">
                    ${_conditionType_} a.tcode is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('tcodeList')">
                ${_conditionType_} a.tcode in
                <foreach collection="conditionParamRef.tcodeList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>

            <if test="conditionParamRef.containsKey('tname')">
                <if test="conditionParamRef.tname != null and conditionParamRef.tname != ''">
                    ${_conditionType_} a.tname like #{${_conditionParam_}.tname}
                </if>
                <if test="conditionParamRef.tname == null">
                    ${_conditionType_} a.tname is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('tnameList')">
                ${_conditionType_} a.tname in
                <foreach collection="conditionParamRef.tnameList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>

            <if test="conditionParamRef.containsKey('matterName')">
                <if test="conditionParamRef.matterName != null and conditionParamRef.matterName != ''">
                    ${_conditionType_} a.matterName like #{${_conditionParam_}.matterName}
                </if>
                <if test="conditionParamRef.matterName == null">
                    ${_conditionType_} a.matterName is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('matterNameList')">
                ${_conditionType_} a.matterName in
                <foreach collection="conditionParamRef.matterNameList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>

            <if test="conditionParamRef.containsKey('englishName')">
                <if test="conditionParamRef.englishName != null and conditionParamRef.englishName != ''">
                    ${_conditionType_} a.englishName like #{${_conditionParam_}.englishName}
                </if>
                <if test="conditionParamRef.englishName == null">
                    ${_conditionType_} a.englishName is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('englishNameList')">
                ${_conditionType_} a.englishName in
                <foreach collection="conditionParamRef.englishNameList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>

            <if test="conditionParamRef.containsKey('matterNo')">
                <if test="conditionParamRef.matterNo != null and conditionParamRef.matterNo != ''">
                    ${_conditionType_} a.matterNo like #{${_conditionParam_}.matterNo}
                </if>
                <if test="conditionParamRef.matterNo == null">
                    ${_conditionType_} a.matterNo is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('matterNoList')">
                ${_conditionType_} a.matterNo in
                <foreach collection="conditionParamRef.matterNoList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>

            <if test="conditionParamRef.containsKey('matterFullName')">
                <if test="conditionParamRef.matterFullName != null and conditionParamRef.matterFullName != ''">
                    ${_conditionType_} a.matterFullName like #{${_conditionParam_}.matterFullName}
                </if>
                <if test="conditionParamRef.matterFullName == null">
                    ${_conditionType_} a.matterFullName is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('matterFullNameList')">
                ${_conditionType_} a.matterFullName in
                <foreach collection="conditionParamRef.matterFullNameList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('deptId')">
                <if test="conditionParamRef.deptId != null ">
                    ${_conditionType_} a.deptId = #{${_conditionParam_}.deptId}
                </if>
                <if test="conditionParamRef.deptId == null">
                    ${_conditionType_} a.deptId is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('deptIdList')">
                ${_conditionType_} a.deptId in
                <foreach collection="conditionParamRef.deptIdList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('deptIdStart') and conditionParamRef.deptIdStart != null">
                ${_conditionType_} a.deptId <![CDATA[ >= ]]> #{${_conditionParam_}.deptIdStart}
            </if>
            <if test="conditionParamRef.containsKey('deptIdEnd') and conditionParamRef.deptIdEnd != null">
                ${_conditionType_} a.deptId <![CDATA[ <= ]]> #{${_conditionParam_}.deptIdEnd}
            </if>


            <if test="conditionParamRef.containsKey('deptName')">
                <if test="conditionParamRef.deptName != null and conditionParamRef.deptName != ''">
                    ${_conditionType_} a.deptName like #{${_conditionParam_}.deptName}
                </if>
                <if test="conditionParamRef.deptName == null">
                    ${_conditionType_} a.deptName is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('deptNameList')">
                ${_conditionType_} a.deptName in
                <foreach collection="conditionParamRef.deptNameList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('total')">
                <if test="conditionParamRef.total != null ">
                    ${_conditionType_} a.total = #{${_conditionParam_}.total}
                </if>
                <if test="conditionParamRef.total == null">
                    ${_conditionType_} a.total is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('totalList')">
                ${_conditionType_} a.total in
                <foreach collection="conditionParamRef.totalList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('totalStart') and conditionParamRef.totalStart != null">
                ${_conditionType_} a.total <![CDATA[ >= ]]> #{${_conditionParam_}.totalStart}
            </if>
            <if test="conditionParamRef.containsKey('totalEnd') and conditionParamRef.totalEnd != null">
                ${_conditionType_} a.total <![CDATA[ <= ]]> #{${_conditionParam_}.totalEnd}
            </if>

            <if test="conditionParamRef.containsKey('sort')">
                <if test="conditionParamRef.sort != null ">
                    ${_conditionType_} a.sort = #{${_conditionParam_}.sort}
                </if>
                <if test="conditionParamRef.sort == null">
                    ${_conditionType_} a.sort is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('sortList')">
                ${_conditionType_} a.sort in
                <foreach collection="conditionParamRef.sortList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('sortStart') and conditionParamRef.sortStart != null">
                ${_conditionType_} a.sort <![CDATA[ >= ]]> #{${_conditionParam_}.sortStart}
            </if>
            <if test="conditionParamRef.containsKey('sortEnd') and conditionParamRef.sortEnd != null">
                ${_conditionType_} a.sort <![CDATA[ <= ]]> #{${_conditionParam_}.sortEnd}
            </if>

            <if test="conditionParamRef.containsKey('isRecommend')">
                <if test="conditionParamRef.isRecommend != null ">
                    ${_conditionType_} a.isRecommend = #{${_conditionParam_}.isRecommend}
                </if>
                <if test="conditionParamRef.isRecommend == null">
                    ${_conditionType_} a.isRecommend is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('isRecommendList')">
                ${_conditionType_} a.isRecommend in
                <foreach collection="conditionParamRef.isRecommendList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('isRecommendStart') and conditionParamRef.isRecommendStart != null">
                ${_conditionType_} a.isRecommend <![CDATA[ >= ]]> #{${_conditionParam_}.isRecommendStart}
            </if>
            <if test="conditionParamRef.containsKey('isRecommendEnd') and conditionParamRef.isRecommendEnd != null">
                ${_conditionType_} a.isRecommend <![CDATA[ <= ]]> #{${_conditionParam_}.isRecommendEnd}
            </if>

            <if test="conditionParamRef.containsKey('source')">
                <if test="conditionParamRef.source != null ">
                    ${_conditionType_} a.source = #{${_conditionParam_}.source}
                </if>
                <if test="conditionParamRef.source == null">
                    ${_conditionType_} a.source is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('sourceList')">
                ${_conditionType_} a.source in
                <foreach collection="conditionParamRef.sourceList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('sourceStart') and conditionParamRef.sourceStart != null">
                ${_conditionType_} a.source <![CDATA[ >= ]]> #{${_conditionParam_}.sourceStart}
            </if>
            <if test="conditionParamRef.containsKey('sourceEnd') and conditionParamRef.sourceEnd != null">
                ${_conditionType_} a.source <![CDATA[ <= ]]> #{${_conditionParam_}.sourceEnd}
            </if>


            <if test="conditionParamRef.containsKey('createTime')">
                <if test="conditionParamRef.createTime != null ">
                    ${_conditionType_} a.createTime = #{${_conditionParam_}.createTime}
                </if>
                <if test="conditionParamRef.createTime == null">
                    ${_conditionType_} a.createTime is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('createTimeStart') and conditionParamRef.createTimeStart != null and conditionParamRef.createTimeStart!=''">
                ${_conditionType_} a.createTime <![CDATA[ >= ]]> STR_TO_DATE(left(concat(#{${_conditionParam_}.createTimeStart},' 00:00:00'),19),'%Y-%m-%d %k:%i:%s')
            </if>
            <if test="conditionParamRef.containsKey('createTimeEnd') and conditionParamRef.createTimeEnd != null and conditionParamRef.createTimeEnd!=''">
                ${_conditionType_} a.createTime <![CDATA[ <= ]]> STR_TO_DATE(left(concat(#{${_conditionParam_}.createTimeEnd},' 23:59:59'),19),'%Y-%m-%d %k:%i:%s')
            </if>
            <if test="conditionParamRef.containsKey('createUserId')">
                <if test="conditionParamRef.createUserId != null ">
                    ${_conditionType_} a.createUserId = #{${_conditionParam_}.createUserId}
                </if>
                <if test="conditionParamRef.createUserId == null">
                    ${_conditionType_} a.createUserId is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('createUserIdList')">
                ${_conditionType_} a.createUserId in
                <foreach collection="conditionParamRef.createUserIdList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('createUserIdStart') and conditionParamRef.createUserIdStart != null">
                ${_conditionType_} a.createUserId <![CDATA[ >= ]]> #{${_conditionParam_}.createUserIdStart}
            </if>
            <if test="conditionParamRef.containsKey('createUserIdEnd') and conditionParamRef.createUserIdEnd != null">
                ${_conditionType_} a.createUserId <![CDATA[ <= ]]> #{${_conditionParam_}.createUserIdEnd}
            </if>


            <if test="conditionParamRef.containsKey('updateTime')">
                <if test="conditionParamRef.updateTime != null ">
                    ${_conditionType_} a.updateTime = #{${_conditionParam_}.updateTime}
                </if>
                <if test="conditionParamRef.updateTime == null">
                    ${_conditionType_} a.updateTime is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('updateTimeStart') and conditionParamRef.updateTimeStart != null and conditionParamRef.updateTimeStart!=''">
                ${_conditionType_} a.updateTime <![CDATA[ >= ]]> STR_TO_DATE(left(concat(#{${_conditionParam_}.updateTimeStart},' 00:00:00'),19),'%Y-%m-%d %k:%i:%s')
            </if>
            <if test="conditionParamRef.containsKey('updateTimeEnd') and conditionParamRef.updateTimeEnd != null and conditionParamRef.updateTimeEnd!=''">
                ${_conditionType_} a.updateTime <![CDATA[ <= ]]> STR_TO_DATE(left(concat(#{${_conditionParam_}.updateTimeEnd},' 23:59:59'),19),'%Y-%m-%d %k:%i:%s')
            </if>
    </sql>
    <sql id="_orderCols_">
        <if test="orderColList != null and !orderColList.isEmpty()">
            order by
            <trim suffixOverrides=","  suffix="">
                <foreach collection="orderColList" open="" close="" index="index" item="item" separator=",">
                     ${item.colName} ${item.sortKind}
                </foreach>
            </trim>
        </if>
        <if test="(orderColList == null or orderColList.isEmpty()) and orderCol != null and !orderCol.isEmpty()">
            order by
            <trim suffixOverrides=","  suffix="">
                    <if test="orderCol.containsKey('id')">
                        a.id
                        <if test='orderCol.id != null and "DESC".equalsIgnoreCase(orderCol.id)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('siteId')">
                        a.siteId
                        <if test='orderCol.siteId != null and "DESC".equalsIgnoreCase(orderCol.siteId)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('tid')">
                        a.tid
                        <if test='orderCol.tid != null and "DESC".equalsIgnoreCase(orderCol.tid)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('tcode')">
                        a.tcode
                        <if test='orderCol.tcode != null and "DESC".equalsIgnoreCase(orderCol.tcode)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('tname')">
                        a.tname
                        <if test='orderCol.tname != null and "DESC".equalsIgnoreCase(orderCol.tname)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('matterName')">
                        a.matterName
                        <if test='orderCol.matterName != null and "DESC".equalsIgnoreCase(orderCol.matterName)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('englishName')">
                        a.englishName
                        <if test='orderCol.englishName != null and "DESC".equalsIgnoreCase(orderCol.englishName)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('matterNo')">
                        a.matterNo
                        <if test='orderCol.matterNo != null and "DESC".equalsIgnoreCase(orderCol.matterNo)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('matterFullName')">
                        a.matterFullName
                        <if test='orderCol.matterFullName != null and "DESC".equalsIgnoreCase(orderCol.matterFullName)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('deptId')">
                        a.deptId
                        <if test='orderCol.deptId != null and "DESC".equalsIgnoreCase(orderCol.deptId)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('deptName')">
                        a.deptName
                        <if test='orderCol.deptName != null and "DESC".equalsIgnoreCase(orderCol.deptName)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('total')">
                        a.total
                        <if test='orderCol.total != null and "DESC".equalsIgnoreCase(orderCol.total)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('sort')">
                        a.sort
                        <if test='orderCol.sort != null and "DESC".equalsIgnoreCase(orderCol.sort)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('isRecommend')">
                        a.isRecommend
                        <if test='orderCol.isRecommend != null and "DESC".equalsIgnoreCase(orderCol.isRecommend)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('source')">
                        a.source
                        <if test='orderCol.source != null and "DESC".equalsIgnoreCase(orderCol.source)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('createTime')">
                        a.createTime
                        <if test='orderCol.createTime != null and "DESC".equalsIgnoreCase(orderCol.createTime)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('createUserId')">
                        a.createUserId
                        <if test='orderCol.createUserId != null and "DESC".equalsIgnoreCase(orderCol.createUserId)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('updateTime')">
                        a.updateTime
                        <if test='orderCol.updateTime != null and "DESC".equalsIgnoreCase(orderCol.updateTime)'>DESC</if>
                        ,
                    </if>
            </trim>
        </if>
    </sql>
    <sql id="_group_by_">
        <if test="groupList != null and !groupList.isEmpty()">
            GROUP BY
            <trim suffixOverrides=","  suffix="">
                <foreach collection="groupList" open="" close="" index="index" item="item" separator=",">
                    ${item}
                </foreach>
            </trim>
        </if>
    </sql>
</mapper>